import { middlewareEventScale, middlewareEventSelect } from '@idraw/core';
import type { CoreEvent, Data } from '@idraw/types';
export interface IDrawEventKeys {
    select: typeof middlewareEventSelect;
    scale: typeof middlewareEventScale;
    change: 'change';
}
export type IDrawEvent = CoreEvent & {
    change: {
        data: Data;
        type: 'updateElement' | 'deleteElement' | 'moveElement' | 'addElement' | 'dragElement' | 'resizeElement' | 'setData' | 'undo' | 'redo' | 'other';
    };
};
declare const EventKeys: {
    select: typeof middlewareEventSelect;
    scale: typeof middlewareEventScale;
    change: 'change';
};
export { EventKeys };
