import type { Data, LoadItemMap, ViewScaleInfo, ViewSizeInfo } from '@idraw/types';
export interface ExportImageFileBaseOptions {
    devicePixelRatio: number;
}
export type ExportImageFileOptions = ExportImageFileBaseOptions & {
    data: Data;
    width: number;
    height: number;
    loadItemMap: LoadItemMap;
    viewScaleInfo: ViewScaleInfo;
    viewSizeInfo: ViewSizeInfo;
};
export type ExportImageFileResult = {
    blobURL: string | null;
    width: number;
    height: number;
    devicePixelRatio: number;
};
export declare function exportImageFileBlobURL(opts: ExportImageFileOptions): Promise<ExportImageFileResult>;
