var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Renderer } from '@idraw/renderer';
import { Calculator } from '@idraw/board';
import { createOffscreenContext2D } from '@idraw/util';
export function exportImageFileBlobURL(opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const { data, width, height, devicePixelRatio, viewScaleInfo, viewSizeInfo, loadItemMap } = opts;
        let viewContext = createOffscreenContext2D({ width, height, devicePixelRatio });
        let calculator = new Calculator({ viewContext });
        let renderer = new Renderer({
            viewContext,
            calculator
        });
        renderer.setLoadItemMap(loadItemMap);
        renderer.drawData(data, {
            viewScaleInfo,
            viewSizeInfo,
            forceDrawAll: true
        });
        let blobURL = null;
        let offScreenCanvas = viewContext.$getOffscreenCanvas();
        if (offScreenCanvas) {
            const blob = yield offScreenCanvas.convertToBlob();
            blobURL = window.URL.createObjectURL(blob);
        }
        offScreenCanvas = null;
        viewContext = null;
        calculator = null;
        renderer = null;
        return {
            blobURL,
            width,
            height,
            devicePixelRatio
        };
    });
}
