var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _iDraw_instances, _iDraw_core, _iDraw_opts, _iDraw_init;
import { Core, MiddlewareSelector, MiddlewareScroller, MiddlewareScaler, MiddlewareRuler, MiddlewareTextEditor, middlewareEventSelect, MiddlewareDragger } from '@idraw/core';
import { createElement, insertElementToListByPosition, updateElementInList, deleteElementInList, moveElementPosition, getElementPositionFromList, calcElementListSize, filterCompactData, calcViewCenterContent, calcViewCenter } from '@idraw/util';
import { defaultSettings } from './config';
import { exportImageFileBlobURL } from './file';
export class iDraw {
    constructor(mount, options) {
        _iDraw_instances.add(this);
        _iDraw_core.set(this, void 0);
        _iDraw_opts.set(this, void 0);
        const opts = Object.assign(Object.assign({}, defaultSettings), options);
        const { width, height, devicePixelRatio, createCustomContext2D } = opts;
        const core = new Core(mount, { width, height, devicePixelRatio, createCustomContext2D });
        __classPrivateFieldSet(this, _iDraw_core, core, "f");
        __classPrivateFieldSet(this, _iDraw_opts, opts, "f");
        __classPrivateFieldGet(this, _iDraw_instances, "m", _iDraw_init).call(this);
    }
    reset(opts) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        const { enableRuler, enableScale, enableScroll, enableSelect, enableTextEdit, enableDrag } = opts;
        if (enableScroll === true) {
            core.use(MiddlewareScroller);
        }
        else if (enableScroll === false) {
            core.disuse(MiddlewareScroller);
        }
        if (enableSelect === true) {
            core.use(MiddlewareSelector);
        }
        else if (enableSelect === false) {
            core.disuse(MiddlewareSelector);
        }
        if (enableScale === true) {
            core.use(MiddlewareScaler);
        }
        else if (enableScale === false) {
            core.disuse(MiddlewareScaler);
        }
        if (enableRuler === true) {
            core.use(MiddlewareRuler);
        }
        else if (enableRuler === false) {
            core.disuse(MiddlewareRuler);
        }
        if (enableTextEdit === true) {
            core.use(MiddlewareTextEditor);
        }
        else if (enableTextEdit === false) {
            core.disuse(MiddlewareTextEditor);
        }
        if (enableDrag === true) {
            core.use(MiddlewareDragger);
        }
        else if (enableDrag === false) {
            core.disuse(MiddlewareDragger);
        }
        core.refresh();
        __classPrivateFieldSet(this, _iDraw_opts, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _iDraw_opts, "f")), opts), "f");
    }
    setData(data) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        core.setData(data);
        core.trigger('change', { data, type: 'setData' });
    }
    getData(opts) {
        const data = __classPrivateFieldGet(this, _iDraw_core, "f").getData();
        if (data && (opts === null || opts === void 0 ? void 0 : opts.compact) === true) {
            return filterCompactData(data, {
                loadItemMap: __classPrivateFieldGet(this, _iDraw_core, "f").getLoadItemMap()
            });
        }
        return data;
    }
    getViewInfo() {
        return __classPrivateFieldGet(this, _iDraw_core, "f").getViewInfo();
    }
    scale(opts) {
        __classPrivateFieldGet(this, _iDraw_core, "f").scale(opts);
    }
    setViewScale(opts) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        core.setViewScale(opts);
        core.refresh();
    }
    centerContent(opts) {
        const data = (opts === null || opts === void 0 ? void 0 : opts.data) || __classPrivateFieldGet(this, _iDraw_core, "f").getData();
        const { viewSizeInfo } = this.getViewInfo();
        if (Array.isArray(data === null || data === void 0 ? void 0 : data.elements) && (data === null || data === void 0 ? void 0 : data.elements.length) > 0) {
            const result = calcViewCenterContent(data, { viewSizeInfo });
            this.setViewScale(result);
        }
    }
    resize(opts) {
        __classPrivateFieldGet(this, _iDraw_core, "f").resize(opts);
    }
    on(name, callback) {
        __classPrivateFieldGet(this, _iDraw_core, "f").on(name, callback);
    }
    off(name, callback) {
        __classPrivateFieldGet(this, _iDraw_core, "f").off(name, callback);
    }
    trigger(name, e) {
        __classPrivateFieldGet(this, _iDraw_core, "f").trigger(name, e);
    }
    selectElement(uuid) {
        this.selectElements([uuid]);
    }
    selectElements(uuids) {
        this.trigger(middlewareEventSelect, { uuids });
    }
    selectElementByPosition(position) {
        this.selectElementsByPositions([position]);
    }
    selectElementsByPositions(positions) {
        this.trigger(middlewareEventSelect, { positions });
    }
    cancelElements() {
        this.trigger(middlewareEventSelect, { uuids: [] });
    }
    createElement(type, opts) {
        const { viewScaleInfo, viewSizeInfo } = __classPrivateFieldGet(this, _iDraw_core, "f").getViewInfo();
        return createElement(type, (opts === null || opts === void 0 ? void 0 : opts.element) || {}, (opts === null || opts === void 0 ? void 0 : opts.viewCenter) === true
            ? {
                viewScaleInfo,
                viewSizeInfo
            }
            : undefined);
    }
    updateElement(element) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        const data = core.getData() || { elements: [] };
        updateElementInList(element.uuid, element, data.elements);
        core.setData(data);
        core.refresh();
        core.trigger('change', { data, type: 'updateElement' });
    }
    addElement(element, opts) {
        var _a;
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        const data = core.getData() || { elements: [] };
        if (!opts || !((_a = opts === null || opts === void 0 ? void 0 : opts.position) === null || _a === void 0 ? void 0 : _a.length)) {
            data.elements.push(element);
        }
        else if (opts === null || opts === void 0 ? void 0 : opts.position) {
            const position = [...opts === null || opts === void 0 ? void 0 : opts.position];
            insertElementToListByPosition(element, position, data.elements);
        }
        core.setData(data);
        core.refresh();
        core.trigger('change', { data, type: 'addElement' });
        return data;
    }
    deleteElement(uuid) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        const data = core.getData() || { elements: [] };
        deleteElementInList(uuid, data.elements);
        core.setData(data);
        core.refresh();
        core.trigger('change', { data, type: 'deleteElement' });
    }
    moveElement(uuid, to) {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        const data = core.getData() || { elements: [] };
        const from = getElementPositionFromList(uuid, data.elements);
        const { elements: list } = moveElementPosition(data.elements, { from, to });
        data.elements = list;
        core.setData(data);
        core.refresh();
        core.trigger('change', { data, type: 'moveElement' });
    }
    getImageBlobURL(opts) {
        return __awaiter(this, void 0, void 0, function* () {
            const data = this.getData() || { elements: [] };
            const { devicePixelRatio } = opts;
            const outputSize = calcElementListSize(data.elements);
            const { viewSizeInfo } = this.getViewInfo();
            return yield exportImageFileBlobURL({
                width: outputSize.w,
                height: outputSize.h,
                devicePixelRatio,
                data,
                viewScaleInfo: { scale: 1, offsetLeft: -outputSize.x, offsetTop: -outputSize.y, offsetBottom: 0, offsetRight: 0 },
                viewSizeInfo: Object.assign(Object.assign({}, viewSizeInfo), { devicePixelRatio }),
                loadItemMap: __classPrivateFieldGet(this, _iDraw_core, "f").getLoadItemMap()
            });
        });
    }
    isDestroyed() {
        return __classPrivateFieldGet(this, _iDraw_core, "f").isDestroyed();
    }
    destroy() {
        const core = __classPrivateFieldGet(this, _iDraw_core, "f");
        core.destroy();
    }
    getViewCenter() {
        const { viewScaleInfo, viewSizeInfo } = this.getViewInfo();
        return calcViewCenter({ viewScaleInfo, viewSizeInfo });
    }
    $onBoardWatcherEvents() {
        __classPrivateFieldGet(this, _iDraw_core, "f").onBoardWatcherEvents();
    }
    $offBoardWatcherEvents() {
        __classPrivateFieldGet(this, _iDraw_core, "f").offBoardWatcherEvents();
    }
}
_iDraw_core = new WeakMap(), _iDraw_opts = new WeakMap(), _iDraw_instances = new WeakSet(), _iDraw_init = function _iDraw_init() {
    const { enableRuler, enableScale, enableScroll, enableSelect, enableTextEdit, enableDrag } = __classPrivateFieldGet(this, _iDraw_opts, "f");
    const core = __classPrivateFieldGet(this, _iDraw_core, "f");
    enableScroll === true && core.use(MiddlewareScroller);
    enableSelect === true && core.use(MiddlewareSelector);
    enableScale === true && core.use(MiddlewareScaler);
    enableRuler === true && core.use(MiddlewareRuler);
    enableTextEdit === true && core.use(MiddlewareTextEditor);
    enableDrag === true && core.use(MiddlewareTextEditor);
};
